> For the complete documentation index, see [llms.txt](https://docs.medcrypt.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.medcrypt.com/medcrypt-documentation/guardian/api-overview/api-reference/classes.md).

# Classes

The [medcrypt namespace ](/medcrypt-documentation/guardian/api-overview/api-reference/namespaces/namespacemedcrypt.md)contains the [guardian namespace](/medcrypt-documentation/guardian/api-overview/api-reference/namespaces/namespacemedcrypt-guardian.md), which includes the following classes, structures, and enumerations:

## **Core classes**

* [Guardian](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-guardian.md) class:
  * **Description:** Root of Guardian system.
  * **Location:** medcrypt::guardian::Guardian
* [AuthenticationManager](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-authenticationmanager.md) class:
  * **Description:** Container for authentication restrictions.
  * **Location:** medcrypt::guardian::AuthenticationManager
* [ChannelGuard](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-channelguard.md) class:
  * **Description:** Name channel within a [Session](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-session.md).
  * **Location:** medcrypt::guardian::ChannelGuard
* [SecureOperation](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-secureoperation.md) class:
  * **Description:** Named standalone operation.
  * **Location:** medcrypt::guardian::SecureOperation
* [Service](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-service.md) class:
  * **Description:** Named group of connection and channel configurations.
  * **Location:** medcrypt::guardian::Service
* [Session](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-session.md) class:
  * **Description:** Individual connection within a [Service](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-service.md).
  * **Location:** medcrypt::guardian::Session
* [Task](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-task.md) class:
  * **Description:** Multithreading container.
  * **Location:** medcrypt::guardian::Task
* [TransportInterface](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-transportinterface.md) class:
  * **Description:** [ConfigureTransport()](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-service.md#function-configuretransport) required interface.
  * **Location:** medcrypt::guardian::TransportInterface

## **Data structures**

* [AuthenticationDomain](/medcrypt-documentation/guardian/api-overview/api-reference/classes/structmedcrypt-guardian-authenticationdomain.md) struct:
  * **Description:** Authentication restriction container. Restrictions for use by an authentication agent.
  * **Location:** medcrypt::guardian::AuthenticationDomain
* [InitializeOptions](/medcrypt-documentation/guardian/api-overview/api-reference/classes/structmedcrypt-guardian-initializeoptions.md) struct:
  * **Description:** Options used by [Initialize()](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-guardian.md#function-initialize) during setup.
  * **Location:** medcrypt::guardian::InitializeOptions
* [ProvisioningOptions](/medcrypt-documentation/guardian/api-overview/api-reference/classes/structmedcrypt-guardian-provisioningoptions.md) struct:
  * **Description:** Options used by [StartProvisioningOnline()](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-guardian.md#function-startprovisioningonline).
  * **Location:** medcrypt::guardian::ProvisioningOptions

### Utility namespace & structures

The [guardian namespace](/medcrypt-documentation/guardian/api-overview/api-reference/namespaces/namespacemedcrypt-guardian.md) also includes the [utilities](/medcrypt-documentation/guardian/api-overview/api-reference/namespaces/namespacemedcrypt-guardian-utilities.md) namespace, which includes the following structures:

* [InitializeFiles](/medcrypt-documentation/guardian/api-overview/api-reference/classes/structmedcrypt-guardian-utilities-initializefiles.md) struct:
  * **Description:** Storage for initialization files used by [Initialize()](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-guardian.md#function-initialize).
  * **Location:** medcrypt::guardian::utilities::InitializeFiles
* [ProvisionFiles](/medcrypt-documentation/guardian/api-overview/api-reference/classes/structmedcrypt-guardian-utilities-provisionfiles.md) struct:
  * **Description:** Storage for generating provision request files in [GenerateProvisionRequest()](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-guardian.md#function-generateprovisionrequest).
  * **Location:** medcrypt::guardian::utilities::ProvisionFiles
* [ProvisionOnlineFiles](/medcrypt-documentation/guardian/api-overview/api-reference/classes/structmedcrypt-guardian-utilities-provisiononlinefiles.md) struct:
  * **Description:** Storage for online provisioning files in [StartProvisioningOnline()](/medcrypt-documentation/guardian/api-overview/api-reference/classes/classmedcrypt-guardian-guardian.md#function-startprovisioningonline).
  * **Location:** medcrypt::guardian::utilities::ProvisionOnlineFiles

## **Other namespaces**

* [AuthenticationAllowDenyEnum](/medcrypt-documentation/guardian/api-overview/api-reference/namespaces/namespacemedcrypt-guardian-authenticationallowdenyenum.md) namespace:
  * **Description:** Determines whether a specified list is in an allow or deny list.
  * **Location:** medcrypt::guardian::AuthenticationAllowDenyEnum
* [GuardianStatusEnum](/medcrypt-documentation/guardian/api-overview/api-reference/namespaces/namespacemedcrypt-guardian-guardianstatusenum.md) namespace:
  * **Description:** Status codes returned by Guardian functions.
  * **Location:** medcrypt::guardian::GuardianStatusEnum
* [LogLevelEnum](/medcrypt-documentation/guardian/api-overview/api-reference/namespaces/namespacemedcrypt-guardian-loglevelenum.md) namespace:
  * **Description:** Log levels returned by Guardian functions.
  * **Location:** medcrypt::guardian::LogLevelEnum


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.medcrypt.com/medcrypt-documentation/guardian/api-overview/api-reference/classes.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
